

import {Component} from '@angular/core';
import {IonicPage, NavController, NavParams, AlertController, ToastController, ModalController, App} from 'ionic-angular';
import {AuthService} from "../../providers/auth-service";
import {CalendarModal, CalendarModalOptions, CalendarResult} from "ion2-calendar";
import {OfficePage} from '../office/office';
/**
 * Created By : ZULQANI FAUZI
 * Created Date : 23/07/2018
 * Updated Date : 24/07/2018
 */

@IonicPage()
@Component({
    selector: 'page-ro',
    templateUrl: 'ro.html',
})
export class RoPage {
    resposeData: any;
    recartDataRo: any;
    dataProduct: any;
    noRecords: boolean = false;
    userDetails: any;
    cartDataRo: any;
    results: any;
    total_item: number;
    userPostData = {
        nama_depan: "",
        nama_belakang: "",
        id_member: ""
    };
    tiba: Date;
    userCartRo = {
        pengajuan: "",
        tiba: "",
        cart_id: "",
        id_pelanggan: "",
        nama_pelanggan: "",
        username: "",
        ItemID: "",
        quantity: "",
        price: "",
        token: "",
        cart_item_id: "",
        catatan: "",
        diskon: "",
        jumlah_diskon: 0,
        promo: "",
        id_promo: "",
        pajak: true,
        ppn: 0,
        type_cart: "",
    }
    items: any[] = [];
    constructor(public navCtrl: NavController, public navParams: NavParams,
        public modalCtrl: ModalController,
        public authService: AuthService,
        public app: App,
        public alertCtrl: AlertController,
        private toastCtrl: ToastController) {
        const data = JSON.parse(localStorage.getItem("userData"));
        this.userDetails = data.userData;
        this.userCartRo.username = this.userDetails.username;
        var d = new Date(), month = '' + (d.getMonth() + 1), day = '' + d.getDate(), year = d.getFullYear();
        var n = month + "/" + day + "/" + year;
        var newdate = new Date(n);
        newdate.setDate(newdate.getDate() + 20);
        var dd = newdate.getDate();
        var mm = newdate.getMonth() + 1;
        var yy = newdate.getFullYear();
        this.userCartRo.pengajuan = year + "-" + month + "-" + day;
        this.userCartRo.tiba = yy + "-" + mm + "-" + dd;
        this.userCartRo.type_cart = "2";
        this.getProduk();
        this.getCart();
    }

    getProduk() {
        this.authService.postData(this.userPostData, "stockProduct").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.productData) {
                    this.dataProduct = this.resposeData.productData;
                    for (let i = 0; i < this.resposeData.productData.length; i++) {
                        let a = this.resposeData.productData[i].ItemName;
                        let b = this.resposeData.productData[i].ItemID;
                        let c = this.resposeData.productData[i].UOMName;
                        let d = this.resposeData.productData[i].Qnty;
                        this.items.push({
                            "ItemName": a,
                            "ItemID": b,
                            "UOMName": c,
                            "Qnty": d
                        });
                    }
                } else {
                    this.presentToast("Gagal terhubung ke server.");
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    insertCart($data) {
        this.userCartRo.price = '0';
        this.userCartRo.quantity = "10";
        this.userCartRo.type_cart = "2";
        this.userCartRo.ItemID = $data.ItemID;
        this.userCartRo.id_pelanggan = '1';
        console.log(this.userCartRo);
        if (this.userCartRo.ItemID) {
            this.authService.postData(this.userCartRo, "insertCart").then(
                result => {
                    this.resposeData = result;
                    if (this.resposeData.cartData) {
                        this.cartDataRo = this.resposeData.cartData;
                        this.total_item = this.cartDataRo.length;
                        setTimeout(() => {
                        }, 150);
                    }
                },
                err => {
                    this.presentToast("Gagal terhubung ke server.");
                }
            );
        } else {
            this.presentToast("Gagal mengambil produk.");
        }
    }

    getCart() {
        this.userCartRo.type_cart = "2";
        this.authService.postData(this.userCartRo, "getCart").then(
            result => {
                this.recartDataRo = result;
                if (this.recartDataRo.cartData) {
                    this.cartDataRo = this.recartDataRo.cartData;
                    this.userCartRo.cart_id = this.cartDataRo[0].cart_id;
                    this.userCartRo.id_pelanggan = this.cartDataRo[0].id_pelanggan;
                    this.userCartRo.nama_pelanggan = this.cartDataRo[0].nama_depan + " " + this.cartDataRo[0].nama_belakang;
                    this.userCartRo.promo = this.cartDataRo[0].promo;
                    this.total_item = this.cartDataRo.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    updateCart($value) {
        this.userCartRo.cart_item_id = $value.cart_item_id;
        this.userCartRo.quantity = $value.quantity;
        this.userCartRo.price = $value.price;
        this.userCartRo.ItemID = $value.product_id;
        this.authService.postData(this.userCartRo, "updateCart").then(
            result => {
                this.recartDataRo = result;
                if (this.recartDataRo.cartData) {
                    this.cartDataRo = this.recartDataRo.cartData;
                    this.total_item = this.cartDataRo.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    deleteCart($value) {
        this.userCartRo.cart_item_id = $value.cart_item_id;
        this.userCartRo.quantity = $value.quantity;
        this.userCartRo.price = $value.price;
        this.userCartRo.ItemID = $value.product_id;
        this.authService.postData(this.userCartRo, "deleteCart").then(
            result => {
                this.recartDataRo = result;
                if (this.recartDataRo.cartData) {
                    this.cartDataRo = this.recartDataRo.cartData;
                    this.total_item = this.cartDataRo.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    insertRo() {
        this.authService.postData(this.userCartRo, "getCart").then(
            result => {
                this.recartDataRo = result;
                if (this.recartDataRo.cartData) {
                    this.cartDataRo = this.recartDataRo.cartData;
                    this.userCartRo.cart_id = this.cartDataRo[0].cart_id;
                    console.log(this.userCartRo);
                    if (this.userCartRo.cart_id) {
                        this.authService.postData(this.userCartRo, "insertRo").then(
                            result => {
                                this.doAlert();
                                this.app.getRootNav().setRoot(OfficePage);
                            },
                            err => {
                                this.presentToast("Gagal terhubung ke server.");
                            }
                        );
                    } else {
                        this.presentToast("Gagal mengambil produk.");
                    }
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    doAlert() {
        let alert = this.alertCtrl.create({
            title: 'Sukses',
            subTitle: 'Request Order telah dikirim. Silahkan menunggu untuk proses selanjutnya.',
            buttons: ['Ok']
        });

        alert.present();
    }

    setItems() {
        this.items;
    }

    onClear() {
        return this.getProduk();
    }
    onCancel() {
        return this.getProduk();
    }

    onInput(ev: any) {
        this.setItems();
        let val = ev.target.value;

        if (val && val.trim() !== '') {
            this.items = this.items.filter(function (item) {
                return item.ItemName.toLowerCase().includes(val.toLowerCase());
            });
        }
    }

    openCalendar() {
        const options: CalendarModalOptions = {
            canBackwardsSelected: true,
            title: 'Pilih Tanggal',
            defaultDate: new Date()
        };

        let myCalendar = this.modalCtrl.create(CalendarModal, {
            options: options
        });

        myCalendar.present();

        myCalendar.onDidDismiss((date: CalendarResult, type: string) => {
            if (date === null) {
                this.userCartRo.tiba = this.userCartRo.tiba;
            } else {
                this.userCartRo.tiba = date.string;
            }
        });
    }

    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    